//------------------------------------------------------------------
// Random walk index developed by Micheal Poulos
// source : TASC 10:9 (385-389): Are There Persistent Cycles?
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DarkGray
#property indicator_style3  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0

#import "random walk index.dll"
   void iRWI(double &rates[][6],int length, double& results[],int totalBars,int shift);
#import

//
//
//
//
//

extern string TimeFrame = "Current time frame";  // Time frame
extern int    RWILength = 25;

double RWIUp[];
double RWIDown[];
double Zline[];
double rates[][6];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,RWIUp);
   SetIndexBuffer(1,RWIDown);
   SetIndexBuffer(2,Zline);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Random walk index ("+RWILength+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double results[2];
#define _rwiUp 0
#define _rwiDo 1

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { RWIUp[0] = MathMin(limit+1,Bars-1); return(0); } 
         if (timeFrame!=Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  RWIUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",RWILength,0,y);
                  RWIDown[i] = iCustom(NULL,timeFrame,indicatorFileName,"",RWILength,1,y);
                  Zline[i]   = 1.00;
            }
            return(0);
         }
         if (ArrayRange(rates,0)!=Bars) ArrayCopyRates(rates,NULL,0);
         int totalRates = ArrayRange(rates,0);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {  
      rates[i][1] = Open[i];
      rates[i][2] = Low[i];
      rates[i][3] = High[i];
      rates[i][4] = Close[i];
      iRWI(rates,RWILength,results,totalRates,i);
         RWIUp[i]   = results[_rwiUp];
         RWIDown[i] = results[_rwiDo];
         Zline[i]   = 1.00;
   }         
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,120,60,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                              return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}